#ifndef STATESIZE_H
#include "nb_celp.h"
#include "sb_celp.h"

// these values are from ...
//    nb_encoder_init() - nb_celp.c
//    sb_encoder_init() - sb_celp.c
#if SPEEX_ENABLE_NB
#define SPEEX_ENCODER_NB_STATE_SIZE  sizeof(EncState)
#define SPEEX_ENCODER_NB_BUFFER_SIZE (8000 * sizeof(float))
#define SPEEX_DECODER_NB_STATE_SIZE  sizeof(DecState)
#define SPEEX_DECODER_NB_BUFFER_SIZE (4000 * sizeof(float))
#else
#define SPEEX_ENCODER_NB_STATE_SIZE  0
#define SPEEX_ENCODER_NB_BUFFER_SIZE 0
#define SPEEX_DECODER_NB_STATE_SIZE  0
#define SPEEX_DECODER_NB_BUFFER_SIZE 0
#endif // SPEEX_ENABLE_NB

#if SPEEX_ENABLE_WB || SPEEX_ENABLE_UWB
#define SPEEX_ENCODER_WB_STATE_SIZE  sizeof(SBEncState)
#define SPEEX_ENCODER_WB_BUFFER_SIZE (8000 * sizeof(float))
#define SPEEX_DECODER_WB_STATE_SIZE  sizeof(SBDecState)
#define SPEEX_DECODER_WB_BUFFER_SIZE (6000 * sizeof(float))
#else
#define SPEEX_ENCODER_WB_STATE_SIZE  0
#define SPEEX_ENCODER_WB_BUFFER_SIZE 0
#define SPEEX_DECODER_WB_STATE_SIZE  0
#define SPEEX_DECODER_WB_BUFFER_SIZE 0
#endif // SPEEX_ENABLE_WB || SPEEX_ENABLE_UWB

#define SPEEX_ENCODER_STATE_SIZE (max(SPEEX_ENCODER_NB_STATE_SIZE, \
                                      SPEEX_ENCODER_WB_STATE_SIZE) + \
                                  max(SPEEX_ENCODER_NB_BUFFER_SIZE, \
                                      SPEEX_ENCODER_WB_BUFFER_SIZE))
#define SPEEX_DECODER_STATE_SIZE (max(SPEEX_DECODER_NB_STATE_SIZE,  \
                                      SPEEX_DECODER_WB_STATE_SIZE) + \
                                  max(SPEEX_DECODER_NB_BUFFER_SIZE, \
                                      SPEEX_DECODER_WB_BUFFER_SIZE))

#endif // STATESIZE_H